var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { path } from 'ramda';
import React from 'react';
import { QueryBuilderRow } from '../QueryBuilderRow';
var QueryBuilderRowsGroup = function (_a) {
    var _b = _a.className, className = _b === void 0 ? undefined : _b, rowClasses = _a.rowClasses, rowsData = _a.rowsData, lastRowAttributeSelectorProps = _a.lastRowAttributeSelectorProps, filterSelectorRef = _a.filterSelectorRef, filterSelectorRefIndex = _a.filterSelectorRefIndex, rowProps = __rest(_a, ["className", "rowClasses", "rowsData", "lastRowAttributeSelectorProps", "filterSelectorRef", "filterSelectorRefIndex"]);
    var renderRow = function (rowData, index, rowsData) {
        var previousRow = index > 0 ? path([index - 1], rowsData) : null;
        var lastRowProps = index === rowsData.length
            ? {
                attributeSelectorProps: lastRowAttributeSelectorProps
            }
            : {};
        return (React.createElement(QueryBuilderRow, __assign({ key: rowData && rowData.id, rowData: rowData, previousRowData: previousRow, classes: rowClasses, filterSelectorRef: index === filterSelectorRefIndex ? filterSelectorRef : undefined }, rowProps, lastRowProps)));
    };
    return (React.createElement("div", { "data-reltio-id": "reltio-query-builder-rows-group", className: className },
        rowsData.map(renderRow),
        renderRow(null, rowsData.length, rowsData)));
};
var typedMemo = React.memo;
export default typedMemo(QueryBuilderRowsGroup);
